
interface Visitor<R>{
  R visit(Tree.Prog e);
  R visit(Tree.MultExpr e);
  R visit(Tree.AddExpr e);
  R visit(Tree.IntLit e);
  R visit(Tree.Var e);
  R visit(Tree.FunDef e);
  R visit(Tree.FunCall e);
  R visit(Tree.TypeDef typeDef);
  R visit(Tree.ConDef conDef);
  R visit(Tree.Param param);
}
